<?php

/*
create thumbnail from various image types ##

usage ##
GM_thumb($src, $dst, $dstx, $dsty, 'show');
$src = 'large.png'; // original image location ##
$dst = 'small.jpg'; // destination image location ##
$dstx = '90'; // width of new image ##
$dsty = '90'; // height of new image ##
*/

function GM_thumb( $src, $dst, $dstx, $dsty, $show ){

	if ( !file_exists ($src) ) { die("file <strong>$src</strong> not found."); } // file_exists ?
	list( $width, $height, $type ) = getimagesize( $src ); // Get the original dimentions
	if ( $type != 1 && $type != 2 && $type != 3 ) { die("Your file is not a supported format."); }
		
	if ( $width >= $dstx && $height >= $dsty ) {
		$proportion_X = $width / $dstx;
		$proportion_Y = $height / $dsty;
	
		if ($proportion_X > $proportion_Y ) {
			$proportion = $proportion_Y;
		} else {
			$proportion = $proportion_X ;
		}
		
		$target['width'] = $dstx * $proportion;
		$target['height'] = $dsty * $proportion;
		$original['diagonal_center'] = round(sqrt(($width*$width)+($height*$height))/2);
		$target['diagonal_center'] = round(sqrt(($target['width']*$target['width']) + ($target['height']*$target['height']))/2);
		$crop = round($original['diagonal_center'] - $target['diagonal_center']);
	
		if ( $proportion_X < $proportion_Y ){
			$target['x'] = 0;
			$target['y'] = round((($height/2)*$crop)/$target['diagonal_center']);
		} else {
			$target['x'] =  round((($width/2)*$crop)/$target['diagonal_center']);
			$target['y'] = 0;
		}
		
		if ( $type == 1 ) { 
			$from = imagecreatefromgif($src); 
		} else if ( $type == 2 ) { 
			$from = imagecreatefromjpeg($src); 
		} else if ( $type == 3 ) { 
			$from = imagecreatefrompng($src); 
		}	
		
		$new = ImageCreateTrueColor ( $dstx,$dsty );
		imagecopyresampled ( $new,  $from,  0, 0, $target['x'], $target['y'], $dstx, $dsty, $target['width'], $target['height'] );
	
		if ( $type == 1 ) { 
			imagegif($new, $dst); 
		} else if ( $type == 2 ) { 
			imagejpeg($new, $dst, 70); 
		} else if ( $type == 3 ) { 
			imagepng($new, $dst); 
		}
		
	} else {
    #echo 'I did nada: $width: = '.$width.' - asked: '.$dstx.', $height: '.$height.' - asked: '.$dsty.'<br />';
  
  }
	if ( $show ) { echo '<img src="'.$dst.'" /><br /><img src="'.$src.'" />'; } // show original and new image ##
}

#######################################

// function to echo variable, with formatting & comment ##
function GM_e($GM_e, $GM_e_name, $GM_e_comment='') {
	if ($GM_e) {
		$GM_e_output = "$GM_e_name = <strong>$GM_e</strong>; ";
	} else { $GM_e_output = '';	
	}
	if ($GM_e_comment) {
		$GM_e_output_comment = $GM_e_comment;
		if ($GM_e) { $GM_e_output_comment = ' ------- '.$GM_e_output_comment; } // add filler if comment and variables to be shown ##
	} else { $GM_e_output_comment = '';
	}
	if ($_SESSION['debug'] == 1) {
		echo "<p style='background: #dddddd; color: #000000; padding: 4px;'>$GM_e_output $GM_e_output_comment</p>";
	}
}

/* usage
GM_e($variable,'$variable','this is my comment');
*/

##################################################

// function to make ( copy ) file ##
function GM_copy ( $from, $to, $mode ) {
	if ( @copy ( $from, $to ) ) {
		chmod ( $to, octdec( $mode ) );
		touch ( $to, filemtime( $from ) ); // to track last modified time
		GM_e ( '', '', $from.' copied to '.$to );
	} else {
		GM_e ( '', '', 'cannot copy '.$from.' to '.$to );
	}
}

##################################################

// function to make recursive directories ##
function GM_mkdir ( $path, $mode, $way = '' ) {
	umask(0);
	$exp = explode( "/", $path );
	foreach( $exp as $n ) {
		$way .= $n.'/';
		if( !file_exists( $way ) ) mkdir( $way, octdec($mode) );
		#GM_e ( '', '', 'directory '.$way.' created.' );
	}
}

// get image size ##
function GM_filesize ($size, $retstring = null) {
   // adapted from code at http://aidanlister.com/repos/v/function.size_readable.php ##
   $sizes = array('B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
   if ($retstring === null) { $retstring = '%01.2f %s'; }
   $lastsizestring = end($sizes);
   foreach ($sizes as $sizestring) {
           if ($size < 1024) { break; }
           if ($sizestring != $lastsizestring) { $size /= 1024; }
   }
   if ($sizestring == $sizes[0]) { $retstring = '%01d %s'; } // Bytes aren't normally fractional ##
   return sprintf($retstring, $size, $sizestring);
}

// delete file, avoiding permission issues ##
function GM_unlink ($path) {
	if ( file_exists ($path) ) {
		@unlink ($path);
		GM_e('','',$path.' ~ file deleted.');
	} else {
		GM_e('','',$path.' ~ does not exist.');
	}	
}

?>